/*
 * Lab2_4C.c
 *
 *  Created on: 03.12.2012  HRPWM
 *      Author: bormann
 */
#include "F2806x_Device.h"
#include "SFO_V6.h"
extern void InitSysCtrl(void);
Uint16 PWM_Freq = 71;		// fPWM = 90MHz/(71+1) = 1.25 MHz
Uint16 PWM_Duty = 22;		// PWM - duty = 31% active high
Uint16 MEP_Steps = 24;		// number of MEP steps (150ps)
int MEP_ScaleFactor; // Global variable used by the SFO library
volatile struct EPWM_REGS *ePWM[PWM_CH] =
             {  &EPwm1Regs, &EPwm1Regs, &EPwm2Regs, &EPwm3Regs, &EPwm4Regs};
void main(void)
{
	Uint16 status;
	InitSysCtrl();						// 90 MHz 28069
	EALLOW;
	SysCtrlRegs.WDCR = 0x00AF;
	GpioCtrlRegs.GPAMUX1.bit.GPIO0 = 1;	// ePWM1A
	GpioCtrlRegs.GPAPUD.bit.GPIO0 = 0;	// enable pull-up
	EDIS;

	do
	{
		status = SFO();	 // calculate MEP steps and store in HRMSTEP of ePWM1
	}while(status == 0);
	EPwm1Regs.TBCTL.all = 0xC030;
	/* 1100 0000 0011 0000
	 * 15-14: 2;	FreeRun on Halt
	 * 13	: 0;	Phase Direction
	 * 12-10: 0;	CLKDIV /1
	 * 9-7  : 0;    HSPCKLDIV  /1
	 * 6	: 0;    no SWFRCSYNC
	 * 5-4  : 3;	disable SYNCOUT
	 * 3    : 0;    use TBPRD shadow
	 * 2	: 0;    do not use PHSEN
	 * 1-0  : 0;	Count - up mode */
	EPwm1Regs.TBPRD = PWM_Freq;
	/*	fpwm = fcpu    / (1 * (TBPRD+1) * CLKDIV * HSPCLKDIV)
	 *  1.25 MHz = 90 MHz / (1 * (71+1)     *  1     * 1)
	 */
	EPwm1Regs.CMPA.half.CMPA = PWM_Duty; 	// set duty 31%
	EPwm1Regs.CMPCTL.all = 0;		// default mode , shadow enabled
	EPwm1Regs.AQCTLA.all = 0x0012;  // ZRO = 2  ; set on CTR = 0
	 	 	 	 	 	 	 	 	// CAU = 1  ; clear on CTR = CMPA
	EPwm1Regs.CMPA.half.CMPAHR = (MEP_Steps << 8);
	EALLOW;
	EPwm1Regs.HRCNFG.all = 0x2;   // bit 1-0 =  2:  falling edge control
	EDIS;
	while(1)
	{
		    		EALLOW;
		    		SysCtrlRegs.WDKEY = 0x55;	// service key #1
		    		SysCtrlRegs.WDKEY = 0xAA;	// service key #2
		    		EDIS;
	}
}




